Get a list of Worker Pools
GET /api
Also reachable at /api, /api.
Lists the name and ID of of the Worker Pools in the supplied Octopus Deploy Space. The results will be sorted by the SortOrder field on each Worker Pool.
Path Parameters
spaceIdstring (required)
The ID of the space containing the resource(s).
Query Parameters
idsarray of string
List of Worker Pool IDs which if specified, filters the result to only include Worker Pools with matching IDs.namestring
The exact name of a Worker Pool to be matched.partialNamestring
A partial or complete name to search on. This will perform a “contains” style match against the supplied name or name-fragment.skipinteger
Number of items to skip. Defaults to zero. Minimum0.takeinteger
Number of items to take. Defaults to 10. Minimum0.
Response
200 — The requested list of Worker Pools
Idstring
Gets or sets a unique identifier for this resource.ItemTypestringItemsarray of objectCanAddWorkersbooleanDescriptionstring
Gets or sets a short description of this pool that can be used to explain the purpose of the pool to other users. May describe the kinds of machines in the pool. This field may contain markdown.Idstring
Gets or sets a unique identifier for this resource.IsDefaultboolean
Is this the default pool. The default pool is used for steps that don’t specify a worker pool. The default pool, if empty, uses the builtin worker to run steps.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Gets or sets the name of this pool. This should be short, preferably 5-20 characters.SlugstringSortOrderinteger
Gets or sets a number indicating the priority of this pool in sort order. Pools with a lower sort order will appear in the UI before items with a higher sort order.SpaceIdstringWorkerPoolTypeenum
Allowed values:StaticWorkerPool,DynamicWorkerPool.
ItemsPerPageintegerLastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LastPageNumberintegerLinksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.NumberOfPagesintegerTotalResultsinteger
Example Response
{
"Id": "string",
"ItemType": "string",
"Items": [
{
"CanAddWorkers": true,
"Description": "string",
"Id": "string",
"IsDefault": true,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Slug": "string",
"SortOrder": 0,
"SpaceId": "string",
"WorkerPoolType": "StaticWorkerPool"
}
],
"ItemsPerPage": 0,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LastPageNumber": 0,
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"NumberOfPages": 0,
"TotalResults": 0
}Create a new Worker Pool
POST /api
Also reachable at /api, /api.
Path Parameters
spaceIdstring (required)
Request Body
Descriptionstring
Gets or sets a short description of this pool that can be used to explain the purpose of the pool to other users. May describe the kinds of machines in the pool. This field may contain markdown.IsDefaultboolean
Is this the default pool. The default pool is used for steps that don’t specify a worker pool. The default pool, if empty, uses the builtin worker to run steps.Namestring (required)
Gets or sets the name of this pool. This should be short, preferably 5-20 characters. Minimum length 1.SlugstringSortOrderinteger
Gets or sets a number indicating the priority of this pool in sort order. Pools with a lower sort order will appear in the UI before items with a higher sort order.SpaceIdstring (required)WorkerPoolTypeenum (required)
Allowed values:StaticWorkerPool,DynamicWorkerPool.WorkerTypestring
Response
201 — Created
CanAddWorkersbooleanDescriptionstring
Gets or sets a short description of this pool that can be used to explain the purpose of the pool to other users. May describe the kinds of machines in the pool. This field may contain markdown.Idstring
Gets or sets a unique identifier for this resource.IsDefaultboolean
Is this the default pool. The default pool is used for steps that don’t specify a worker pool. The default pool, if empty, uses the builtin worker to run steps.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Gets or sets the name of this pool. This should be short, preferably 5-20 characters.SlugstringSortOrderinteger
Gets or sets a number indicating the priority of this pool in sort order. Pools with a lower sort order will appear in the UI before items with a higher sort order.SpaceIdstringWorkerPoolTypeenum
Allowed values:StaticWorkerPool,DynamicWorkerPool.
Example Request
{
"Description": "string",
"IsDefault": true,
"Name": "string",
"Slug": "string",
"SortOrder": 0,
"SpaceId": "string",
"WorkerPoolType": "StaticWorkerPool",
"WorkerType": "string"
}Example Response
{
"CanAddWorkers": true,
"Description": "string",
"Id": "string",
"IsDefault": true,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Slug": "string",
"SortOrder": 0,
"SpaceId": "string",
"WorkerPoolType": "StaticWorkerPool"
}Get a list of Worker Pools
GET /api
Also reachable at /api, /api.
Lists the name and ID of of the Worker Pools in the supplied Octopus Deploy Space. The results will be sorted by the SortOrder field on each Worker Pool.
Path Parameters
spaceIdstring (required)
The ID of the space containing the resource(s).
Query Parameters
idsarray of string
List of Worker Pool IDs which if specified, filters the result to only include Worker Pools with matching IDs.
Response
200 — The list of requested Worker Pools
CanAddWorkersbooleanDescriptionstring
Gets or sets a short description of this pool that can be used to explain the purpose of the pool to other users. May describe the kinds of machines in the pool. This field may contain markdown.Idstring
Gets or sets a unique identifier for this resource.IsDefaultboolean
Is this the default pool. The default pool is used for steps that don’t specify a worker pool. The default pool, if empty, uses the builtin worker to run steps.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Gets or sets the name of this pool. This should be short, preferably 5-20 characters.SlugstringSortOrderinteger
Gets or sets a number indicating the priority of this pool in sort order. Pools with a lower sort order will appear in the UI before items with a higher sort order.SpaceIdstringWorkerPoolTypeenum
Allowed values:StaticWorkerPool,DynamicWorkerPool.
Example Response
[
{
"CanAddWorkers": true,
"Description": "string",
"Id": "string",
"IsDefault": true,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Slug": "string",
"SortOrder": 0,
"SpaceId": "string",
"WorkerPoolType": "StaticWorkerPool"
}
]List the available Worker Types for the Dynamic Worker Pool
GET /api
Also reachable at /api, /api.
Returns a list of the available Worker Types for the Dynamic Worker Pool
Path Parameters
spaceIdstring (required)
Response
200 — The requested Dynamic Worker Types
IdstringLinksobjectWorkerTypesarray of objectDeprecationDateUtcstring
Formatdate-time.DescriptionstringEndOfLifeDateUtcstring
Formatdate-time.IdstringStartDateUtcstring
Formatdate-time.Typestring
Error Responses
500internal_server_error— Unable to connect to the Dynamic Worker service
Example Response
{
"Id": "string",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"WorkerTypes": [
{
"DeprecationDateUtc": "2020-01-01T00:00:00.000Z",
"Description": "string",
"EndOfLifeDateUtc": "2020-01-01T00:00:00.000Z",
"Id": "string",
"StartDateUtc": "2020-01-01T00:00:00.000Z",
"Type": "string"
}
]
}PUT /api/{spaceId}/workerpools/sortorder
PUT /api
Also reachable at /api, /api.
Takes an array of work pool IDs as the request body, uses the order of items in the array to sort the worker pools on the server. The ID of every worker pool must be specified.
Path Parameters
spaceIdstring (required)
Request Body
A array of string payload.
Response
200 — Success
Example Request
[
"string"
]List all worker pools, including a summary of worker information
GET /api
Also reachable at /api, /api.
Lists all worker pools, including a summary of machine information.
Path Parameters
spaceIdstring (required)
Query Parameters
commStylesarray of stringhealthStatusesarray of stringhideEmptyWorkerPoolsbooleanidsarray of stringisDisabledbooleanmachinePartialNamestringpartialNamestringshellNamesarray of string
Response
200 — The requested Worker Pool Summary
MachineEndpointSummariesobjectMachineHealthStatusSummariesobjectMachineIdsForCalamariUpgradearray of stringMachineIdsForTentacleUpgradearray of stringTentacleUpgradesRequiredbooleanTotalDisabledMachinesintegerTotalMachinesintegerWorkerPoolSummariesarray of objectMachineEndpointSummariesobjectMachineHealthStatusSummariesobjectMachineIdsForCalamariUpgradearray of stringMachineIdsForTentacleUpgradearray of stringTentacleUpgradesRequiredbooleanTotalDisabledMachinesintegerTotalMachinesintegerWorkerPoolobject
Example Response
{
"MachineEndpointSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"MachineHealthStatusSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"MachineIdsForCalamariUpgrade": [
"string"
],
"MachineIdsForTentacleUpgrade": [
"string"
],
"TentacleUpgradesRequired": true,
"TotalDisabledMachines": 0,
"TotalMachines": 0,
"WorkerPoolSummaries": [
{
"MachineEndpointSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"MachineHealthStatusSummaries": {
"additionalProp1": 0,
"additionalProp2": 0,
"additionalProp3": 0
},
"MachineIdsForCalamariUpgrade": [
"string"
],
"MachineIdsForTentacleUpgrade": [
"string"
],
"TentacleUpgradesRequired": true,
"TotalDisabledMachines": 0,
"TotalMachines": 0,
"WorkerPool": {
"CanAddWorkers": true,
"Description": "string",
"Id": "string",
"IsDefault": true,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {},
"Name": "string",
"Slug": "string",
"SortOrder": 0,
"SpaceId": "string",
"WorkerPoolType": "StaticWorkerPool"
}
}
]
}Get the available Worker Pool types
GET /api
Also reachable at /api, /api.
Lists the available Worker Pool types.
Path Parameters
spaceIdstring (required)
Response
200 — The list of Supported Worker Pool Types
IdstringLinksobjectSupportedPoolTypesarray of enum
Allowed values:StaticWorkerPool,DynamicWorkerPool.
Example Response
{
"Id": "string",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"SupportedPoolTypes": [
"StaticWorkerPool"
]
}Get a Worker Pool by ID
GET /api
Also reachable at /api, /api.
Path Parameters
idstring (required)spaceIdstring (required)
Response
200 — The requested Worker Pool.
CanAddWorkersbooleanDescriptionstring
Gets or sets a short description of this pool that can be used to explain the purpose of the pool to other users. May describe the kinds of machines in the pool. This field may contain markdown.Idstring
Gets or sets a unique identifier for this resource.IsDefaultboolean
Is this the default pool. The default pool is used for steps that don’t specify a worker pool. The default pool, if empty, uses the builtin worker to run steps.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Gets or sets the name of this pool. This should be short, preferably 5-20 characters.SlugstringSortOrderinteger
Gets or sets a number indicating the priority of this pool in sort order. Pools with a lower sort order will appear in the UI before items with a higher sort order.SpaceIdstringWorkerPoolTypeenum
Allowed values:StaticWorkerPool,DynamicWorkerPool.
Example Response
{
"CanAddWorkers": true,
"Description": "string",
"Id": "string",
"IsDefault": true,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Slug": "string",
"SortOrder": 0,
"SpaceId": "string",
"WorkerPoolType": "StaticWorkerPool"
}Modify an existing worker pool
PUT /api
Also reachable at /api, /api.
Updates an existing worker pool.
Path Parameters
idstring (required)
The ID of the worker pool.spaceIdstring (required)
The ID of the space containing the resource(s).
Request Body
Descriptionstring
The description of the worker pool.Idstring (required)
The ID of the worker pool.IsDefaultboolean (required)
Whether the worker pool is the default or not.Namestring (required)
The name of the worker pool. Minimum length 1.Slugstring
The slug of the worker pool.SpaceIdstring (required)
The ID of the space containing the resource(s).WorkerTypestring
The worker image.
Response
200 — Confirms that a Worker Pool was modified, containing the updated Worker Pool
CanAddWorkersbooleanDescriptionstring
Gets or sets a short description of this pool that can be used to explain the purpose of the pool to other users. May describe the kinds of machines in the pool. This field may contain markdown.Idstring
Gets or sets a unique identifier for this resource.IsDefaultboolean
Is this the default pool. The default pool is used for steps that don’t specify a worker pool. The default pool, if empty, uses the builtin worker to run steps.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.Namestring
Gets or sets the name of this pool. This should be short, preferably 5-20 characters.SlugstringSortOrderinteger
Gets or sets a number indicating the priority of this pool in sort order. Pools with a lower sort order will appear in the UI before items with a higher sort order.SpaceIdstringWorkerPoolTypeenum
Allowed values:StaticWorkerPool,DynamicWorkerPool.
Example Request
{
"Description": "string",
"Id": "string",
"IsDefault": true,
"Name": "string",
"Slug": "string",
"SpaceId": "string",
"WorkerType": "string"
}Example Response
{
"CanAddWorkers": true,
"Description": "string",
"Id": "string",
"IsDefault": true,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Name": "string",
"Slug": "string",
"SortOrder": 0,
"SpaceId": "string",
"WorkerPoolType": "StaticWorkerPool"
}Delete an existing Worker Pool
DELETE /api
Also reachable at /api, /api.
Path Parameters
idstring (required)
ID of the Worker Pool to delete.spaceIdstring (required)
Response
200 — Success
Get a list of WorkerResources for the given WorkerPoolResource
GET /api
Also reachable at /api, /api.
Lists all of the machines that belong to the given worker pool.
Path Parameters
idstring (required)
ID of the WorkerPool.spaceIdstring (required)
Query Parameters
commStylesarray of stringdeploymentTargetTypesarray of stringhealthStatusesarray of stringisDisabledbooleanoperatingSystemNamesarray of stringpartialNamestringshellNamesarray of stringskipinteger
Number of items to skip. Defaults to zero. Minimum0.takeinteger
Number of items to take. Defaults to 20. Minimum0.
Response
200 — The requested list of Workers within a Worker Pool
Idstring
Gets or sets a unique identifier for this resource.ItemTypestringItemsarray of objectArchitecturestringEndpointobjectHasLatestCalamaribooleanHealthStatusenum
Allowed values:Healthy,Unavailable,Unknown,HasWarnings,Unhealthy.Idstring
Gets or sets a unique identifier for this resource.IsDisabledbooleanIsInProcessbooleanLastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.MachinePolicyIdstringNamestringOperatingSystemstringOperatingSystemVersionstringShellNamestringShellVersionstringSkipInitialHealthCheckbooleanSlugstringSpaceIdstringStatusSummarystringThumbprintstringUristringWorkerPoolIdsarray of string
ItemsPerPageintegerLastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.LastPageNumberintegerLinksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.NumberOfPagesintegerTotalResultsinteger
Example Response
{
"Id": "string",
"ItemType": "string",
"Items": [
{
"Architecture": "string",
"Endpoint": {
"CommunicationStyle": "None",
"Id": "string",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {}
},
"HasLatestCalamari": true,
"HealthStatus": "Healthy",
"Id": "string",
"IsDisabled": true,
"IsInProcess": true,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"MachinePolicyId": "string",
"Name": "string",
"OperatingSystem": "string",
"OperatingSystemVersion": "string",
"ShellName": "string",
"ShellVersion": "string",
"SkipInitialHealthCheck": true,
"Slug": "string",
"SpaceId": "string",
"StatusSummary": "string",
"Thumbprint": "string",
"Uri": "string",
"WorkerPoolIds": [
"string"
]
}
],
"ItemsPerPage": 0,
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"LastPageNumber": 0,
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"NumberOfPages": 0,
"TotalResults": 0
}